"use strict";
// TODO: pull tests from ditto
Object.defineProperty(exports, "__esModule", { value: true });
// const has = Object.prototype.hasOwnProperty
/**
 * Decode a URI encoded string.
 *
 * @param {String} input The URI encoded string.
 * @returns {String} The decoded string.
 * @api private
 */
function decode(input) {
    return decodeURIComponent(input.replace(/\+/g, ' '));
}
/**
 * Simple query string parser.
 *
 * @param {String} query The query string that needs to be parsed.
 * @returns {Object}
 * @api public
 */
function parse(query) {
    if (!query)
        return {};
    var parser = /([^=?&]+)=?([^&]*)/g;
    var result = {};
    var part;
    // Little nifty parsing hack, leverage the fact that RegExp.exec increments
    // the lastIndex property so we can continue executing this loop until we've
    // parsed all results.
    while ((part = parser.exec(query))) {
        var val = decode(part[2]);
        if (val === '')
            val = true;
        if (val === 'false')
            val = false;
        result[decode(part[1])] = val;
    }
    return result;
}
exports.parse = parse;
/**
 * Transform a query string to an object.
 *
 * @param {Object} obj Object that should be transformed.
 * @param {String} prefix Optional prefix.
 * @returns {String}
 * @api public
 */
// export function stringify(obj: Object, prefix: string) {
//   prefix = prefix || ''
//   var pairs = []
//   //
//   // Optionally prefix with a '?' if needed
//   //
//   if (typeof prefix !== 'string') prefix = '?'
//   for (var key in obj) {
//     if (has.call(obj, key)) {
//       pairs.push(encodeURIComponent(key) + '=' + encodeURIComponent(obj[key]))
//     }
//   }
//   return pairs.length ? prefix + pairs.join('&') : ''
// }
