"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var scaffolding_1 = require("../lib/scaffolding");
var path_1 = require("path");
var mkdir = require("make-dir");
var fs_1 = require("mz/fs");
function page(params) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var root, isTS, ext, pages, pageName, pagePath, rel;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    root = params.root || process.cwd();
                    return [4 /*yield*/, fs_1.exists(path_1.join(root, "tsconfig.json"))];
                case 1:
                    isTS = _a.sent();
                    ext = isTS ? '.tsx' : '.js';
                    pages = path_1.join(root, 'pages');
                    pageName = params.pageName;
                    pagePath = path_1.join(pages, pageName, pageName + ext);
                    rel = path_1.relative(process.cwd(), pagePath);
                    // // TODO: parallel
                    return [4 /*yield*/, mkdir(path_1.dirname(pagePath))];
                case 2:
                    // // TODO: parallel
                    _a.sent();
                    return [4 /*yield*/, fs_1.exists(pagePath)];
                case 3:
                    if (_a.sent()) {
                        throw new Error(rel + " already exists");
                    }
                    if (!isTS) return [3 /*break*/, 5];
                    return [4 /*yield*/, fs_1.writeFile(pagePath, scaffolding_1.createTSPage(pageName))];
                case 4:
                    _a.sent();
                    return [3 /*break*/, 7];
                case 5: return [4 /*yield*/, fs_1.writeFile(pagePath, scaffolding_1.createPage(pageName))];
                case 6:
                    _a.sent();
                    _a.label = 7;
                case 7: return [2 /*return*/];
            }
        });
    });
}
exports.default = page;
