"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var path_1 = require("path");
var fs_1 = require("mz/fs");
var readPkg = require("read-pkg-up");
var mkdir = require("make-dir");
var copy = require("cpy");
var shvl_1 = require("shvl");
function setup(params) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var elmoPkgPath, elmoDir, scaffoldDir, root, pages, statics, types, _a, ver, preactVer, rootPkgPath, pkgPath;
        return tslib_1.__generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, readPkg({ cwd: __dirname })];
                case 1:
                    elmoPkgPath = (_b.sent()).path;
                    elmoDir = path_1.dirname(elmoPkgPath);
                    scaffoldDir = path_1.join(elmoDir, "scaffold");
                    root = params.root || process.cwd();
                    pages = path_1.join(root, 'pages');
                    statics = path_1.join(root, 'static');
                    types = path_1.join(root, 'types');
                    // TODO: parallel
                    return [4 /*yield*/, mkdir(pages)];
                case 2:
                    // TODO: parallel
                    _b.sent();
                    return [4 /*yield*/, mkdir(statics)];
                case 3:
                    _b.sent();
                    return [4 /*yield*/, mkdir(types)];
                case 4:
                    _b.sent();
                    return [4 /*yield*/, copy(scaffoldDir + "/_redirects", root, { overwrite: false })];
                case 5:
                    _b.sent();
                    return [4 /*yield*/, copy(scaffoldDir + "/static/**/*", statics, { overwrite: false })];
                case 6:
                    _b.sent();
                    if (!params.typescript) return [3 /*break*/, 10];
                    return [4 /*yield*/, copy(scaffoldDir + "/pages/*.tsx", pages, { overwrite: false })];
                case 7:
                    _b.sent();
                    return [4 /*yield*/, copy(scaffoldDir + "/pages/index/*.tsx", path_1.join(pages, 'index'), { overwrite: false })];
                case 8:
                    _b.sent();
                    return [4 /*yield*/, copy(scaffoldDir + "/tsconfig.json", root, { overwrite: false })];
                case 9:
                    _b.sent();
                    return [3 /*break*/, 13];
                case 10: return [4 /*yield*/, copy(scaffoldDir + "/pages/*.js", pages, { overwrite: false })];
                case 11:
                    _b.sent();
                    return [4 /*yield*/, copy(scaffoldDir + "/pages/index/*.js", path_1.join(pages, 'index'), { overwrite: false })];
                case 12:
                    _b.sent();
                    _b.label = 13;
                case 13:
                    _a = require(elmoPkgPath), ver = _a.version, preactVer = _a.dependencies.preact;
                    rootPkgPath = path_1.join(root, 'package.json');
                    return [4 /*yield*/, fs_1.exists(rootPkgPath)];
                case 14:
                    if (!!(_b.sent())) return [3 /*break*/, 16];
                    return [4 /*yield*/, fs_1.writeFile(rootPkgPath, "{\n  \"name\": \"" + path_1.basename(root) + "\",\n  \"version\": \"1.0.0\",\n  \"private\": true,\n  \"dependencies\": {\n    \"preact\": \"" + preactVer + "\",\n    \"elmo\": \"" + ver + "\"\n  }\n}")];
                case 15:
                    _b.sent();
                    return [3 /*break*/, 18];
                case 16:
                    pkgPath = require(rootPkgPath);
                    shvl_1.set(pkgPath, "dependencies.preact", preactVer);
                    shvl_1.set(pkgPath, "dependencies.elmo", ver);
                    return [4 /*yield*/, fs_1.writeFile(rootPkgPath, JSON.stringify(pkgPath, null, 2))];
                case 17:
                    _b.sent();
                    _b.label = 18;
                case 18: return [2 /*return*/];
            }
        });
    });
}
exports.default = setup;
