import { URL } from './client/url';
export interface BuildProps {
}
export interface InitialProps {
    render(props: {
        [prop: string]: any;
    }): void;
    redirect(path: string): void;
    params: {
        [param: string]: string;
    };
    url: URL;
}
export declare type File = {
    path: string;
    contents: string;
};
export interface Route {
    path: string;
    regexp: string;
    params: (string | number)[];
}
export interface Params {
    environment: string;
    outpath: string;
    target: string;
    action: string;
    root: string;
    routes: Route[];
    port?: number;
}
export declare type URL = {
    protocol: string;
    host: string;
    port: number;
    hostname: string;
    hash: string;
    search: string;
    query: {
        [s: string]: string | boolean;
    };
    pathname: string;
    href: string;
};
export { default as Document } from './lib/_document';
export { default as Router } from './lib/router';
export { default as Link } from './lib/link';
export { default as Head } from './lib/head';
import * as url from './client/url';
import * as qs from './client/qs';
export { url, qs };
