"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var preact_1 = require("preact");
var Link = /** @class */ (function (_super) {
    tslib_1.__extends(Link, _super);
    function Link(props, context) {
        var _this = _super.call(this, props, context) || this;
        _this.onClick = function (e) {
            if (!_this.context.router) {
                throw new Error('<Link /> no router passed in through context');
            }
            // events shouldn't bubble up to
            // higher <Link /> tags or to
            // submit a form
            //
            // TODO: do we also need e.preventDefault()
            e.stopPropagation();
            _this.context.router.push(_this.props.href);
        };
        return _this;
    }
    Link.prototype.render = function () {
        var _a = this.props, href = _a.href, children = _a.children;
        if (!children || !children[0])
            return null;
        var firstChild = children[0];
        if (firstChild === null)
            return null;
        if (!href ||
            typeof firstChild === 'string' ||
            typeof firstChild === 'number' ||
            !firstChild.hasOwnProperty('nodeName')) {
            return (preact_1.h("a", { href: href, onClick: this.onClick }, children));
        }
        return preact_1.cloneElement(firstChild, { onClick: this.onClick });
    };
    return Link;
}(preact_1.Component));
exports.default = Link;
