"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var preact_1 = require("preact");
var render_1 = require("./render");
var Markup = /** @class */ (function (_super) {
    tslib_1.__extends(Markup, _super);
    function Markup() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Markup.prototype.shouldComponentUpdate = function (_a) {
        var html = _a.html, xml = _a.xml;
        var p = this.props;
        return html !== p.html || xml !== p.xml;
    };
    Markup.prototype.setComponents = function (components) {
        this.upgrader = {};
        if (components) {
            for (var i in components) {
                if (components.hasOwnProperty(i)) {
                    var name_1 = i
                        .replace(/([A-Z]+)([A-Z][a-z0-9])|([a-z0-9]+)([A-Z])/g, '$1$3-$2$4')
                        .toLowerCase();
                    this.upgrader[name_1] = components[i];
                }
            }
        }
    };
    Markup.prototype.render = function (props) {
        if (!props.html && !props.xml)
            return null;
        this.setComponents(props.upgrade);
        var type = props.html ? 'html' : 'xml';
        var vdom = render_1.default(props.html || props.xml, props.upgrade, { type: type });
        return vdom && typeof vdom !== 'string' && vdom.length ? vdom[0] : null;
    };
    return Markup;
}(preact_1.Component));
exports.default = Markup;
