"use strict";
/**
 * Module dependencies
 */
Object.defineProperty(exports, "__esModule", { value: true });
var compile_1 = require("./compile");
var parse_1 = require("./parse");
/**
 * HTML function
 */
function Render(html, upgrader, options) {
    if (html === void 0) { html = ''; }
    if (options === void 0) { options = { type: 'html' }; }
    var dom = parse_1.default(html, options.type);
    if (dom && dom.error)
        throw new Error(dom.error);
    var body = (dom && dom.body) || dom;
    var vdom = compile_1.default(body, upgrader, options);
    if (vdom === null)
        return null;
    if (typeof vdom === 'string')
        return vdom;
    return [vdom];
}
exports.default = Render;
