"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var preact_1 = require("preact");
var Provider = /** @class */ (function (_super) {
    tslib_1.__extends(Provider, _super);
    function Provider(props) {
        return _super.call(this, props) || this;
    }
    Provider.prototype.getChildContext = function () {
        return {
            router: this.props.router,
            url: this.props.url,
            params: this.props.params
        };
    };
    Provider.prototype.render = function () {
        if (!this.props.children)
            return null;
        var firstChild = this.props.children[0];
        if (typeof firstChild === 'string' || typeof firstChild === 'number')
            return null;
        return firstChild;
    };
    return Provider;
}(preact_1.Component));
exports.default = Provider;
