"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
// Turn the path into a route
//
// e.g.
//  - index.js        => /
//  - about.js        => /about
//  - movies/index.js => /movies
//  - index/index.js  => /
function Route(root, entry) {
    var page = path_1.relative(path_1.join(root, 'pages'), entry);
    var base = path_1.basename(page, path_1.extname(page));
    if (base === 'index') {
        var dir = path_1.dirname(page);
        while (dir === 'index') {
            dir = path_1.dirname(dir);
        }
        return dir === '.' ? '/' : '/' + dir;
    }
    else {
        return '/' + base;
    }
}
exports.default = Route;
