"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var glob_1 = require("../../utils/glob");
var path_1 = require("path");
var Watcher = /** @class */ (function () {
    function Watcher(input) {
        this.input = input;
    }
    Watcher.prototype.find = function (compilation) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var root, pages, files;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        root = this.input.root;
                        return [4 /*yield*/, glob_1.default(root, path_1.join('pages', '**'))];
                    case 1:
                        pages = _a.sent();
                        files = compilation.fileDependencies;
                        pages.map(function (page) { return files.add(page); });
                        return [2 /*return*/];
                }
            });
        });
    };
    Watcher.prototype.apply = function (compiler) {
        var _this = this;
        this.input;
        compiler.hooks.afterCompile.tapAsync('watcher', function (compilation, done) {
            _this.find(compilation)
                .then(function () { return done(); })
                .catch(function (err) { return done(err); });
        });
    };
    return Watcher;
}());
exports.default = Watcher;
