"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
// Turn the path into a route
//
// e.g.
//  - index.js        => /
//  - about.js        => /about
//  - movies/index.js => /movies
//  - index/index.js  => /
function rewrite(basedir, ext, page) {
    var rel = path_1.relative(basedir, page);
    var base = path_1.basename(rel, path_1.extname(rel));
    var dir = path_1.dirname(rel);
    if (base === 'index') {
        if (dir === 'index')
            dir = path_1.dirname(dir);
        if (dir === '.')
            return base + ext;
        return path_1.join(dir, base + ext);
    }
    else {
        return path_1.join(dir, base, 'index' + ext);
    }
}
exports.default = rewrite;
// console.log(rewrite('/matt/pages', '.html', '/matt/pages/index.jsx'))
// console.log(rewrite('/matt/pages', '.js', '/matt/pages/index.tsx'))
// console.log(rewrite('/matt/pages', '.html', '/matt/pages/about/index.jsx'))
// console.log(rewrite('/matt/pages', '.js', '/matt/pages/about/index.tsx'))
// console.log(rewrite('/matt/pages', '.html', '/matt/pages/about/sub.jsx'))
// console.log(rewrite('/matt/pages', '.js', '/matt/pages/about/sub.tsx'))
